import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { MonitorRuleIndicators } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-09-15 13:20
 */
interface MonitorRuleIndicatorsCU extends ConditionUtil<MonitorRuleIndicatorsCU>{
    ID:FieldUtil<MonitorRuleIndicatorsCU>;
    INDICATORS_CODE:FieldUtil<MonitorRuleIndicatorsCU>;
    INDICATORS_NAME:FieldUtil<MonitorRuleIndicatorsCU>;
    INDICATORS_UNIT:FieldUtil<MonitorRuleIndicatorsCU>;
    CREATE_TIME:FieldUtil<MonitorRuleIndicatorsCU>;
    UPDATE_TIME:FieldUtil<MonitorRuleIndicatorsCU>;
}

class MonitorRuleIndicatorsCUImpl extends ConditionUtilImpl<MonitorRuleIndicatorsCUImpl> implements MonitorRuleIndicatorsCU{ 
    newInstance(): MonitorRuleIndicatorsCUImpl {
        return new MonitorRuleIndicatorsCUImpl();
    } 
    get ID(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get INDICATORS_CODE(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('indicators_code','indicatorsCode','指标编码', this);
    }
    get INDICATORS_NAME(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('indicators_name','indicatorsName','指标名称', this);
    }
    get INDICATORS_UNIT(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('indicators_unit','indicatorsUnit','指标单位', this);
    }
    get CREATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
}

@Singleton 
class MonitorRuleIndicatorsMU extends TableUtilImpl<MonitorRuleIndicatorsCU,MonitorRuleIndicators>{ 
    tableName  = 'monitor_rule_indicators';
    tableFields  = ['id','indicators_code','indicators_name','indicators_unit','create_time','update_time'];
    modelFields  = ['id','indicatorsCode','indicatorsName','indicatorsUnit','createTime','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): MonitorRuleIndicatorsCU {
        return new MonitorRuleIndicatorsCUImpl();
    }   

    static get ID(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('id','id','主键', new MonitorRuleIndicatorsCUImpl());
    }
    static get INDICATORS_CODE(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('indicators_code','indicatorsCode','指标编码', new MonitorRuleIndicatorsCUImpl());
    }
    static get INDICATORS_NAME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('indicators_name','indicatorsName','指标名称', new MonitorRuleIndicatorsCUImpl());
    }
    static get INDICATORS_UNIT(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('indicators_unit','indicatorsUnit','指标单位', new MonitorRuleIndicatorsCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new MonitorRuleIndicatorsCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new MonitorRuleIndicatorsCUImpl());
    }

    get ID(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.ID;
    }
    get INDICATORS_CODE(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.INDICATORS_CODE;
    }
    get INDICATORS_NAME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.INDICATORS_NAME;
    }
    get INDICATORS_UNIT(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.INDICATORS_UNIT;
    }
    get CREATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<MonitorRuleIndicatorsCU>{ 
        return MonitorRuleIndicatorsMU.UPDATE_TIME;
    }
}
export {MonitorRuleIndicatorsMU, MonitorRuleIndicatorsCU}
